unit SportdagP;
{
 bestanden:
  - Teams.txt
  - Games.txt
  - Times.txt
  - Joker.txt
  - GameType.txt
  - Resultaat.txt
}

{
 Format van resultaat
  per regel a b c d
  a = spel
  b = tijd
  c = score teamA
  d = score teamB
  (TeamA en TeamB volgen eenvoudig uit wedstrijdtabel)
 Format van uitslag
 (2i-1,j)  : eerste team bij spel i gedurende tijd j
 (2i,j)    : tweede team bij spel i gedurende tijd j
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, Grids, ComCtrls, Tabnotbk;

const
  tijden : array[1..10] of string =
  ('09:30 - 10:00', '10:00 - 10:30', '10:30 - 11:00', '11:00 - 11:30',
   '11:30 - 12:00', '13:00 - 13:30', '13:30 - 14:00', '14:00 - 14:30',
   '14:30 - 15:00', '15:00 - 15:30');
  spelwaarden : array[1..20] of integer =
  (30, 27, 24, 22, 20, 18, 16, 14, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1);
  initfile      = 'Init.txt';
  teamfile      = 'Teams.txt';
  gamefile      = 'Games.txt';
  timefile      = 'Times.txt';
  jokerfile     = 'Joker.txt';
  gametypefile  = 'GameType.txt';
  resultfile    = 'Resultaat.txt';
  datadirectory = 'data';
  max           = 1800;

type
  TF_Main = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    S_Spelen: TSpinEdit;
    S_Teams: TSpinEdit;
    L_Spelen: TListBox;
    L_Teams: TListBox;
    L_TimesExtra: TListBox;
    StringGrid_Overzicht: TStringGrid;
    StringGrid_Tijden: TStringGrid;
    StringGrid_Uitslag: TStringGrid;
    StringGrid_Punten_Overzicht: TStringGrid;
    StringGrid_Totaal: TStringGrid;
    StringGrid_Spelen: TStringGrid;
    StringGrid_Punten: TStringGrid;
    C_Special: TCheckBox;
    SD_Overzicht: TSaveDialog;
    SD_Resultaten: TSaveDialog;
    SD_Uitslag: TSaveDialog;
    SD_Punten: TSaveDialog;
    M_HTML_in: TMemo;
    M_HTML_end: TMemo;
    M_HTML: TMemo;
    B_Clear: TButton;
    B_Save: TButton;
    B_Exit: TButton;
    L_SpelNum: TLabel;
    L_TeamNum: TLabel;
    L_SpelNum2: TLabel;
    Panel6: TPanel;
    Panel2: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Panel1: TPanel;
    Label1: TLabel;
    Label4: TLabel;
    Panel3: TPanel;
    Label6: TLabel;
    Label5: TLabel;
    Label12: TLabel;
    Panel4: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    Panel5: TPanel;
    Label9: TLabel;
    Label11: TLabel;
    Label10: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    procedure FormActivate(Sender: TObject);
    procedure S_TeamsChange(Sender: TObject);
    procedure S_SpelenChange(Sender: TObject);
    procedure B_ExitClick(Sender: TObject);
    procedure L_TeamsClick(Sender: TObject);
    procedure L_SpelenClick(Sender: TObject);
    procedure TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure B_SaveClick(Sender: TObject);
    procedure StringGrid_SpelenMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure StringGrid_UitslagMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure B_ClearClick(Sender: TObject);
    procedure C_SpecialClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  F_Main: TF_Main;
  Tab : integer;
  dir : string;
  Jokers, Totaal : array[1..20] of integer;
  Uitslag, Overzicht, Punten : Array[1..20,1..10] of integer;
  DoSave : Boolean;
  Klaar : Array[1..10,1..10] of boolean;

implementation

uses D_WijzigP, D_InvoerP;

{$R *.DFM}

///////////////////
// FormActivate
///////////////////
procedure TF_Main.FormActivate(Sender: TObject);
var
  i, j, n, p, len, spel, tijd, scoreA, scoreB, T1, T2 : integer;
  filename, s, t : string;
  Fin : TextFile;
  Dummy : Boolean;
begin
  Tab := 0;
  dir := ExtractFilePath(Application.ExeName) + datadirectory;
  StringGrid_Overzicht.ColWidths[0] := 85;
  StringGrid_Uitslag.ColWidths[0] := 85;
  StringGrid_Spelen.ColWidths[0] := 100;
  // Initialisatie
  filename := dir + '\' + InitFile;
  AssignFile(Fin, filename);
  {$I-}
  Reset(Fin);
  {$I+}
  if IOResult = 0 then
  begin
    readln(Fin, n);
    S_Teams.Value := n;
    readln(Fin, n);
    S_Spelen.Value := n;
  end
  else
  begin
    S_Teams.Value := 12;
    S_Spelen.Value := 7;
  end;
  // Openen van Teams
  filename := dir + '\' + TeamFile;
  AssignFile(Fin, filename);
  {$I-}
  Reset(Fin);
  {$I+}
  if IOResult = 0 then
  begin
    CloseFile(Fin);
    L_Teams.Items.LoadFromFile(filename);
    n := L_Teams.Items.Count;
  end
  else
  begin
    n := 0;
    L_Teams.Clear;
  end;
  for i := n+1 to S_Teams.Value do L_Teams.Items.Add('Team'+ IntToStr(i));
  // Openen van Spelen
  filename := dir + '\' + GameFile;
  AssignFile(Fin, filename);
  {$I-}
  Reset(Fin);
  {$I+}
  if IOResult = 0 then
  begin
    CloseFile(Fin);
    L_Spelen.Items.LoadFromFile(filename);
    n := L_Spelen.Items.Count;
  end
  else
  begin
    n := 0;
    L_Spelen.Clear;
  end;
  for i := n+1 to S_Spelen.Value do L_Spelen.Items.Add('Spel'+ IntToStr(i));
  // Openen van Tijden
  filename := dir + '\' + TimeFile;
  AssignFile(Fin, filename);
  {$I-}
  Reset(Fin);
  {$I+}
  if IOResult = 0 then
  begin
    CloseFile(Fin);
    L_TimesExtra.Items.LoadFromFile(filename);
    n := L_TimesExtra.Items.Count;
    with StringGrid_Tijden do
    begin
      ColWidths[1] := 115;
      RowCount := 11;
      for i := 1 to n do
      begin
        Cells[0,i] := IntToStr(i);
        Cells[1,i] := L_TimesExtra.Items[i-1];
      end;
    end;
  end
  else n := 0;
  with StringGrid_Tijden do
  begin
    ColWidths[1] := 115;
    RowCount := 11;
    for i := n+1 to 10 do
    begin
      Cells[0,i] := IntToStr(i);
      Cells[1,i] := Tijden[i];
    end;
    RowCount := S_Spelen.Value+1;
  end;
  with StringGrid_Punten do
  begin
    RowCount := 21;
    for i := 1 to 20 do
    begin
      Cells[0,i] := IntToStr(i);
      Cells[1,i] := IntToStr(Spelwaarden[i]);
    end;
    RowCount := S_Teams.Value+1;
  end;
  TabbedNotebook1Change(Sender,1,Dummy);
  // Openen van GameType (min/max) (indien aanwezig)
  filename := dir + '\' + GameTypeFile;
  AssignFile(Fin, filename);
  {$I-}
  Reset(Fin);
  {$I+}
  if IOResult = 0 then
  begin
    CloseFile(Fin);
    L_TimesExtra.Items.LoadFromFile(filename);
    n := L_TimesExtra.Items.Count;
    for i := 1 to n do StringGrid_Spelen.Cells[1, i] := L_TimesExtra.Items[i-1];
    for j := 1 to n do if StringGrid_Spelen.Cells[1, j] = 'min'
    then
    begin
      for i := 1 to S_Spelen.value do
        if Overzicht[2*j-1,i] > 0 then
        begin
          Uitslag[2*j-1,i] := Max;
          Uitslag[2*j,i] := Max;
          StringGrid_Uitslag.Cells[j,i] := IntToStr(Max) + ' - ' + IntToStr(Max);
        end;
    end
    else
    begin
      for i := 1 to S_Spelen.value do
        if Overzicht[2*j-1,i] > 0 then
        begin
          Uitslag[2*j-1,i] := 0;
          Uitslag[2*j,i] := 0;
          StringGrid_Uitslag.Cells[j,i] := '0 - 0';
        end;
    end
  end;
  // Openen van Jokers (indien aanwezig)
  filename := dir + '\' + JokerFile;
  for i := 1 to 20 do Jokers[i] := 0;
  AssignFile(Fin, filename);
  {$I-}
  Reset(Fin);
  {$I+}
  if IOResult = 0 then
  begin
    CloseFile(Fin);
    L_TimesExtra.Items.LoadFromFile(filename);
    for i := 1 to L_TimesExtra.Items.Count do
      Jokers[i] := StrToInt(L_TimesExtra.Items[i-1]);
  end;
  // Klaar
  for i := 1 to 10 do
    for j := 1 to 10 do Klaar[i,j] := false;
  // Openen van Resultaten (indien aanwezig)
  filename := dir + '\' + ResultFile;
  AssignFile(Fin, filename);
  {$I-}
  Reset(Fin);
  {$I+}
  if IOResult = 0 then
  begin
    CloseFile(Fin);
    L_TimesExtra.Items.LoadFromFile(filename);
    n := L_TimesExtra.Items.Count;
    for i := 1 to n do
    begin
      s := L_TimesExtra.Items[i-1];
      p := pos(' ', s);
      t := copy(s, 1, p-1);
      spel := StrToInt(t);
      s := Copy(s, p+1, Length(s)-p);
      p := pos(' ', s);
      t := copy(s, 1, p-1);
      tijd := StrToInt(t);
      s := Copy(s, p+1, Length(s)-p);
      p := pos(' ', s);
      t := copy(s, 1, p-1);
      scoreA := StrToInt(t);
      s := Copy(s, p+1, Length(s)-p);
      scoreB := StrToInt(s);
      T1 := Overzicht[2*Spel-1, Tijd];
      T2 := Overzicht[2*Spel, Tijd];
      Uitslag[2*Spel-1, Tijd] := scoreA;
      Uitslag[2*Spel, Tijd] := scoreB;
      s := '[' + IntToStr(T1) + ']: ' + IntToStr(scoreA);
      if Jokers[T1] = Spel then s := s + '(J)';
      s := s + ' - [' + IntToStr(T2) + ']:' + IntToStr(scoreB);
      if Jokers[T2] = Spel then s := s + '(J)';
      StringGrid_Uitslag.Cells[Spel, Tijd] := s;
      Klaar[Spel,Tijd] := True;
    end;
  end;
  // Punten
  for i := 1 to 20 do
    for j := 1 to 10 do Punten[i,j] := 0;
  L_SpelNum.Caption := IntToStr(S_Spelen.Value);
  L_SpelNum2.Caption := IntToStr(S_Spelen.Value);
  L_TeamNum.Caption := IntToStr(S_Teams.value);
  StringGrid_Punten.Cells[0,0] := 'Team';
  StringGrid_Punten.Cells[1,0] := 'Punten';
  StringGrid_Spelen.Cells[0,0] := 'Spel';
  StringGrid_Spelen.Cells[1,0] := 'Soort spel';
  StringGrid_Punten_Overzicht.ColWidths[1] := 42;
  with StringGrid_Totaal do
  begin
    Cells[0,0] := 'Rang';
    Cells[1,0] := 'TeamNr.';
    Cells[2,0] := 'Team';
    Cells[3,0] := 'Punten';
    Cells[4,0] := 'Joker';
    ColWidths[0] := 42;
    ColWidths[1] := 50;
    ColWidths[3] := 50;
    ColWidths[4] := 42;
    RowCount := S_Teams.value+1;
  end;
  DoSave := False;
end;

///////////////////
// S_TeamsChange
///////////////////
procedure TF_Main.S_TeamsChange(Sender: TObject);
var i : integer;
begin
  if S_Teams.value < L_Teams.Items.Count
    then for i := L_Teams.Items.Count-1 to S_Teams.value do
      L_Teams.Items.delete(i)
    else for i := L_Teams.Items.Count + 1 to S_Teams.Value do
      L_Teams.Items.Add('Team'+ IntToStr(i));
  StringGrid_Punten_Overzicht.RowCount := S_Teams.value+1;
  StringGrid_Punten.RowCount := S_Teams.value+1;
  StringGrid_Totaal.RowCount := S_Teams.value+1;
  L_TeamNum.Caption := IntToStr(S_Teams.value);
  DoSave := True;
end;

///////////////////
// S_SpelenChange
///////////////////
procedure TF_Main.S_SpelenChange(Sender: TObject);
var i : integer;
begin
  if S_Spelen.value < L_Spelen.Items.Count
    then for i := L_Spelen.Items.Count-1 to S_Spelen.value do
      L_Spelen.Items.delete(i)
    else for i := L_Spelen.Items.Count + 1 to S_Spelen.Value do
      L_Spelen.Items.Add('Spel'+ IntToStr(i));
  L_SpelNum.Caption := IntToStr(S_Spelen.Value);
  L_SpelNum2.Caption := IntToStr(S_Spelen.Value);
  StringGrid_Tijden.RowCount := S_Spelen.value+1;
  StringGrid_Punten_Overzicht.ColCount := S_Spelen.value+2;
  DoSave := True;
end;

///////////////////
// L_TeamsClick
///////////////////
procedure TF_Main.L_TeamsClick(Sender: TObject);
var
  s : integer;
begin
  s := L_Teams.ItemIndex;
  Is_OK_Wijzigen := False;
  Dialog_Wijzigen.Caption := 'Wijzigen van Teamnaam';
  Dialog_Wijzigen.L_Text.Caption := 'Wijzig de teamnaam:';
  Dialog_Wijzigen.E_Text.Text := L_Teams.Items[s];
  Dialog_Wijzigen.ShowModal;
  if Is_OK_Wijzigen then
  begin
    L_Teams.Items[s] := Dialog_Wijzigen.GetResult_Wijzigen;
    DoSave := True;
  end;
end;

///////////////////
// L_SpelenClick
///////////////////
procedure TF_Main.L_SpelenClick(Sender: TObject);
var
  s : integer;
begin
  s := L_Spelen.ItemIndex;
  Is_OK_Wijzigen := False;
  Dialog_Wijzigen.Caption := 'Wijzigen van Spelnaam';
  Dialog_Wijzigen.L_Text.Caption := 'Wijzig de spelnaam:';
  Dialog_Wijzigen.E_Text.Text := L_Spelen.Items[s];
  Dialog_Wijzigen.ShowModal;
  if Is_OK_Wijzigen then
  begin
    L_Spelen.Items[s] := Dialog_Wijzigen.GetResult_Wijzigen;
    DoSave := True;
  end;
end;

///////////////////
// StringGrid_SpelenMouseUp
///////////////////
procedure TF_Main.StringGrid_SpelenMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Column, Row: LongInt;
  i : integer;
begin
  StringGrid_Spelen.MouseToCell(X, Y, Column, Row);
  if (Row > 0) and (Column > 0) then
  begin
    if StringGrid_Spelen.Cells[Column, Row] = 'max'
    then
    begin
       StringGrid_Spelen.Cells[Column, Row] := 'min';
       for i := 1 to S_Spelen.value do
         if Overzicht[2*Row-1,i] > 0 then
         begin
           Uitslag[2*Row-1,i] := Max;
           Uitslag[2*Row,i] := Max;
           StringGrid_Uitslag.Cells[Row,i] := IntToStr(Max) + ' - ' + IntToStr(Max);
         end;
    end
    else
    begin if StringGrid_Spelen.Cells[Column, Row] = 'min'
    then
    begin
       StringGrid_Spelen.Cells[Column, Row] := 'verschil';
       for i := 1 to S_Spelen.value do
         if Overzicht[2*Row-1,i] > 0 then
         begin
           Uitslag[2*Row-1,i] := 0;
           Uitslag[2*Row,i] := 0;
           StringGrid_Uitslag.Cells[Row,i] := '0 - 0';
         end;
    end
    else
       StringGrid_Spelen.Cells[Column, Row] := 'max';
       for i := 1 to S_Spelen.value do
         if Overzicht[2*Row-1,i] > 0 then
         begin
           Uitslag[2*Row-1,i] := 0;
           Uitslag[2*Row,i] := 0;
           StringGrid_Uitslag.Cells[Row,i] := '0 - 0';
         end;
    end;
  end
end;

///////////////////
// C_SpecialClick
///////////////////
procedure TF_Main.C_SpecialClick(Sender: TObject);
begin
  ShowMessage('Deze optie is niet geimplementeerd');
end;

///////////////////
// StringGrid_UitslagMouseUp
///////////////////
procedure TF_Main.StringGrid_UitslagMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Spel, Tijd: LongInt;
  T1, T2, R1, R2 : Integer;
  J1, J2 : Boolean;
  s : string;
begin
  StringGrid_Uitslag.MouseToCell(X, Y, Spel, Tijd);
  if (Spel > 0) and (Tijd > 0) then
  begin
    Is_OK_Invoer := False;
    Dialog_Invoer.L_Spel.Caption := L_Spelen.Items[Spel-1];
    Dialog_Invoer.L_Tijd.Caption := StringGrid_Tijden.Cells[1, Tijd];
    T1 := Overzicht[2*Spel-1, Tijd];
    T2 := Overzicht[2*Spel, Tijd];
    if (T1+T2 > 0) then
    begin
      Dialog_Invoer.L_Team1.Caption := L_Teams.Items[T1-1];
      Dialog_Invoer.L_Team2.Caption := L_Teams.Items[T2-1];
      Dialog_Invoer.S_Team1.Value := Uitslag[2*Spel-1, Tijd];
      Dialog_Invoer.S_Team2.Value := Uitslag[2*Spel, Tijd];
      Dialog_Invoer.C_Joker1.Checked := (Jokers[T1] = Spel);
      Dialog_Invoer.C_Joker2.Checked := (Jokers[T2] = Spel);
      Dialog_Invoer.C_Joker1.Enabled := (Jokers[T1] = 0) or (Jokers[T1] = Spel);
      Dialog_Invoer.C_Joker2.Enabled := (Jokers[T2] = 0) or (Jokers[T2] = Spel);
      Dialog_Invoer.ShowModal;
      if Is_OK_Invoer then
      begin
        Dialog_Invoer.GetResult_Invoer(R1, R2, J1, J2);
        Uitslag[2*Spel-1, Tijd] := R1;
        Uitslag[2*Spel, Tijd] := R2;
        if J1 then Jokers[T1] := Spel;
        if J2 then Jokers[T2] := Spel;
        s := '[' + IntToStr(T1) + ']: ' + IntToStr(R1);
        if J1 then s := s + '(J)';
        s := s + ' - [' + IntToStr(T2) + ']:' + IntToStr(R2);
        if J2 then s := s + '(J)';
        StringGrid_Uitslag.Cells[Spel, Tijd] := s;
        Klaar[Spel,Tijd] := True;
      end;
    end;
  end;
end;

///////////////////
// TabbedNotebook1Change
///////////////////
procedure TF_Main.TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
var
  a, b, i, x, spel, len, team, tijd, HulpCount : integer;
  Hulp, HulpTotaal : array[0..20,1..3] of integer;
  PuntToekenning : Array[1..20] of integer;
  Fin : TextFile;
  s : string;
begin
  if Tab = 0 then
  begin
    s := dir + '\' + IntToStr(S_Teams.Value) + '_' + IntToStr(S_Spelen.Value) + '.txt';
    AssignFile(Fin, s);
    {$I-}
    Reset(Fin);
    {$I+}
    if IOResult <> 0 then
      MessageDlg('Bestand niet gevonden: ' + s, mtInformation, [mbOk], 0)
    else
    begin
      for i := 1 to S_Spelen.Value do
      begin
        readln(Fin, s);
        s := s + ' ';
        for spel := 1 to S_Spelen.Value do
        begin
          Overzicht[2*spel-1,i] := ord(s[1]) - ord('A') + 1;
          if Overzicht[2*spel-1,i] > 20 then Overzicht[2*spel-1,i] := 0;
          Overzicht[2*spel,i] := ord(s[2]) - ord('A') + 1;
          if Overzicht[2*spel,i] > 20 then Overzicht[2*spel,i] := 0;
          len := Length(s);
          s := copy(s, 4, len-3);
        end;
      end;
      CloseFile(Fin);

      StringGrid_Overzicht.RowCount := S_Spelen.Value + 1;
      StringGrid_Overzicht.ColCount := S_Spelen.Value + 1;
      StringGrid_Spelen.RowCount := S_Spelen.Value + 1;
      StringGrid_Uitslag.RowCount := S_Spelen.Value + 1;
      StringGrid_Uitslag.ColCount := S_Spelen.Value + 1;
      for i := 1 to S_Spelen.Value do
      begin
        StringGrid_Overzicht.Cells[i,0] := L_Spelen.Items[i-1];
        StringGrid_Overzicht.Cells[0,i] := StringGrid_Tijden.Cells[1,i];
        StringGrid_Uitslag.Cells[i,0] := L_Spelen.Items[i-1];
        StringGrid_Uitslag.Cells[0,i] := StringGrid_Tijden.Cells[1,i];
        for spel := 1 to S_Spelen.Value do
          if Overzicht[2*spel,i] = 0
            then
            begin
              StringGrid_Overzicht.Cells[spel,i] := '---';
              StringGrid_Uitslag.Cells[spel,i] := '---';
            end
            else
            begin
              StringGrid_Overzicht.Cells[spel,i] :=
                       Copy(L_Teams.Items[Overzicht[2*spel-1,i]-1],1,6) +' - ' +
                       Copy(L_Teams.Items[Overzicht[2*spel,i]-1],1,6);
              StringGrid_Uitslag.Cells[spel,i] := '0 - 0';
            end;
        StringGrid_Spelen.Cells[0,i] := L_Spelen.Items[i-1];
        StringGrid_Spelen.Cells[1,i] := 'max';
      end;
    end;
    with StringGrid_Punten_Overzicht do
    begin
      for i := 1 to S_Spelen.Value do Cells[i+1,0] := L_Spelen.Items[i-1];
      for i := 1 to S_Teams.Value do Cells[0,i] := L_Teams.Items[i-1];
      Cells[1,0] := 'Totaal';
    end;
  end;
  if Tab = 2 then
  begin
  end;
  if NewTab = 4 then
  begin
    for team := 1 to S_Teams.Value do PuntToekenning[team] := StrToInt(StringGrid_Punten.Cells[1,team]);
    for spel := 1 to S_Spelen.value do
    begin
      HulpCount := 0;
      for i := 0 to S_Teams.Value do Hulp[i,2] := 0;
      if StringGrid_Spelen.Cells[1, Spel] = 'min' then
        for i := 0 to S_Teams.Value do Hulp[i,1] := -max
      else if StringGrid_Spelen.Cells[1, Spel] = 'verschil' then
        for i := 0 to S_Teams.Value do Hulp[0,1] := -100
      else
        for i := 0 to S_Teams.Value do Hulp[0,1] := -100;
      for Tijd := 1 to S_Spelen.value do
        if Klaar[spel,Tijd] then
        begin
          if StringGrid_Spelen.Cells[1, Spel] = 'verschil' then
          begin
            a := Uitslag[2*spel-1,Tijd]-Uitslag[2*spel,Tijd];
            b := -a;
          end
          else if StringGrid_Spelen.Cells[1, Spel] = 'min' then
          begin
            a := -Uitslag[2*spel-1,Tijd];
            b := -Uitslag[2*spel,Tijd];
          end
          else
          begin
            a := Uitslag[2*spel-1,Tijd];
            b := Uitslag[2*spel,Tijd];
          end;
          len := HulpCount;
          while a <= Hulp[len,1] do dec(len);
          if a > Hulp[len,1] then
          begin
            inc(HulpCount);
            for i := HulpCount downto len+2 do Hulp[i,1] := Hulp[i-1,1];
            Hulp[len+1,1] := a;
          end;
          len := HulpCount;
          while b <= Hulp[len,1] do dec(len);
          if b > Hulp[len,1] then
          begin
            inc(HulpCount);
            for i := HulpCount downto len+2 do Hulp[i,1] := Hulp[i-1,1];
            Hulp[len+1,1] := b;
          end;
        end;
      for Tijd := 1 to S_Spelen.value do
        if Klaar[spel,Tijd] then
        begin
          if StringGrid_Spelen.Cells[1, Spel] = 'verschil' then
          begin
            a := Uitslag[2*spel-1,Tijd]-Uitslag[2*spel,Tijd];
            b := -a;
          end
          else if StringGrid_Spelen.Cells[1, Spel] = 'min' then
          begin
            a := -Uitslag[2*spel-1,Tijd];
            b := -Uitslag[2*spel,Tijd];
          end
          else
          begin
            a := Uitslag[2*spel-1,Tijd];
            b := Uitslag[2*spel,Tijd];
          end;
          i := 0;
          while a > Hulp[i,1] do inc(i);
          Hulp[i,2] := Hulp[i,2] + 1;
          i := 0;
          while b > Hulp[i,1] do inc(i);
          Hulp[i,2] := Hulp[i,2] + 1;
        end;
      len := Hulp[HulpCount,2];
      Hulp[HulpCount,2] := 1;
      for i := HulpCount-1 downto 0 do
      begin
        x := len;
        len := len + Hulp[i,2];
        Hulp[i,2] := x + 1;
      end;
//if spel = 1 then
//ShowMessage( IntToStr(Hulp[0,1])+' '+IntToStr(Hulp[1,1])+' '+IntToStr(Hulp[2,1])+#13
//+IntToStr(Hulp[0,2])+' '+IntToStr(Hulp[1,2])+' '+IntToStr(Hulp[2,2]));
      for Tijd := 1 to S_Spelen.value do
        if Klaar[spel,Tijd] then
        begin
          if StringGrid_Spelen.Cells[1, Spel] = 'verschil' then
          begin
            a := Uitslag[2*spel-1,Tijd]-Uitslag[2*spel,Tijd];
            b := -a;
          end
          else if StringGrid_Spelen.Cells[1, Spel] = 'min' then
          begin
            a := -Uitslag[2*spel-1,Tijd];
            b := -Uitslag[2*spel,Tijd];
          end
          else
          begin
            a := Uitslag[2*spel-1,Tijd];
            b := Uitslag[2*spel,Tijd];
          end;
          i := 0;
          while a > Hulp[i,1] do inc(i);
          team := Overzicht[2*Spel-1, Tijd];
          Punten[team,Spel] := PuntToekenning[Hulp[i,2]];
          i := 0;
          while b > Hulp[i,1] do inc(i);
          team := Overzicht[2*Spel, Tijd];
          Punten[team,Spel] := PuntToekenning[Hulp[i,2]];
       end;
//if spel = 1 then
//ShowMessage( IntToStr(Punten[1,1])+' '+IntToStr(Punten[2,1])+#13
//+IntToStr(Punten[1,2])+' '+IntToStr(Punten[2,2]));
    end;
    with StringGrid_Punten_Overzicht do
      for Team := 1 to S_Teams.Value do
      begin
        Totaal[Team] := 0;
        for Spel := 1 to S_Spelen.Value do
          if Punten[team,Spel] > 0 then
          begin
            if Jokers[Team] = Spel then
            begin
              Punten[team,Spel] := 2 * Punten[team,Spel];
              Cells[Spel+1,Team] := IntToStr(Punten[team,Spel]) + ' (J)';
            end
            else Cells[Spel+1,Team] := IntToStr(Punten[team,Spel]);
            Totaal[Team] := Totaal[Team] + Punten[team,Spel];
          end;
          Cells[1,Team] := IntToStr(Totaal[Team]);
      end;
  end;
  if NewTab = 5 then
  begin
    HulpCount := 1;
    for i := 1 to S_Teams.Value do Hulp[i,2] := 0;
    for i := 1 to S_Teams.Value do Hulp[i,1] := 0;
    for Team := 1 to S_Teams.Value do
    begin
      a := Totaal[Team];
      len := HulpCount;
      while a < Hulp[len,1] do dec(len);
      if a > Hulp[len,1] then
      begin
        inc(HulpCount);
        for i := HulpCount downto len+2 do Hulp[i,1] := Hulp[i-1,1];
        Hulp[len+1,1] := a;
      end;
    end;
//ShowMessage( IntToStr(Hulp[1,1])+' '+IntToStr(Hulp[2,1])+#13
//+IntToStr(Hulp[1,2])+' '+IntToStr(Hulp[2,2]));
    for Team := 1 to S_Teams.Value do
    begin
      a := Totaal[Team];
      i := 1;
      while a > Hulp[i,1] do inc(i);
      Hulp[i,2] := Hulp[i,2] + 1;
    end;
    len := Hulp[HulpCount,2];
    Hulp[HulpCount,2] := 1;
    for i := HulpCount-1 downto 1 do
    begin
      x := len;
      len := len + Hulp[i,2];
      Hulp[i,2] := x + 1;
    end;
//ShowMessage( IntToStr(Hulp[1,1])+' '+IntToStr(Hulp[2,1])+' '+IntToStr(Hulp[3,1])+#13
//+IntToStr(Hulp[1,2])+' '+IntToStr(Hulp[2,2])+' '+IntToStr(Hulp[3,2]));
    for Team := 1 to S_Teams.Value do HulpTotaal[Team,1] := 0;
    for Team := 1 to S_Teams.Value do
    begin
      a := Totaal[Team];
      i := HulpCount;
      while a < Hulp[i,1] do dec(i);
      b := Hulp[i,2];
      i := b;
      while HulpTotaal[i,1] > 0 do inc(i);
      HulpTotaal[i,1] := Team;
      HulpTotaal[i,2] := a;
      HulpTotaal[i,3] := b;
    end;
//ShowMessage( IntToStr(HulpTotaal[1,1])+' '+IntToStr(HulpTotaal[2,1])+' '+IntToStr(HulpTotaal[3,1])+#13
//+IntToStr(HulpTotaal[1,2])+' '+IntToStr(HulpTotaal[2,2])+' '+IntToStr(HulpTotaal[3,2])+#13
//+IntToStr(HulpTotaal[1,3])+' '+IntToStr(HulpTotaal[2,3])+' '+IntToStr(HulpTotaal[3,3]));
    with StringGrid_Totaal do
      for Team := 1 to S_Teams.Value do
      begin
        Cells[0,Team] := IntToStr(HulpTotaal[Team,3]);
        Cells[1,Team] := IntToStr(HulpTotaal[Team,1]);
        Cells[2,Team] := L_Teams.Items[HulpTotaal[Team,1]-1];
        Cells[3,Team] := IntToStr(HulpTotaal[Team,2]);
        if Jokers[HulpTotaal[Team,1]] > 0 then
          Cells[4,Team] := L_Spelen.Items[Jokers[HulpTotaal[Team,1]]-1];
      end;
  end;
  Tab := NewTab;
end;

///////////////////
// B_SaveClick
///////////////////
procedure TF_Main.B_SaveClick(Sender: TObject);
var
  i, j, tabpage : integer;
  filename : string;
  Fout : TextFile;
begin
  {In de verschillende stadia moeten verschillende zaken worden bewaard:
   1) Teams & Spelen  : Spelnamen, Teamnamen, Tijden
   2) Speloverzicht   : Speloverzicht in HTML-formaat
   3) Spelresultaten  : Min/Max-lijst, jokers, resultaten, Spelresultaten in HTML-formaat
   4) Puntenoverzicht : Puntenoverzicht in HTML-formaat
   5) Uitslag         : Uitslag in HTML-formaat
  }
  tabpage := TabbedNotebook1.PageIndex;
  case tabpage of
    0:begin // Teams & Spelen
        filename := dir + '\' + InitFile;
        AssignFile(Fout, filename);
        {$I-}
        Rewrite(Fout);
        {$I+}
        if IOResult <> 0 then
          MessageDlg('Schrijffout : ' + filename, mtInformation, [mbOk], 0)
        else
        begin
          writeln(Fout, S_Teams.Value);
          writeln(Fout, S_Spelen.Value);
          CloseFile(Fout);
        end;
        filename := dir + '\' + TeamFile;
        L_Teams.Items.SaveToFile(filename);
        filename := dir + '\' + GameFile;
        L_Spelen.Items.SaveToFile(filename);
        filename := dir + '\' + TimeFile;
        L_TimesExtra.Clear;
        with StringGrid_Tijden do
          For i := 1 to S_Spelen.Value do L_TimesExtra.Items.Add(Cells[1,i]);
        L_TimesExtra.Items.SaveToFile(filename);
      end;
    1:begin // Speloverzicht
        if sd_overzicht.execute then
        begin
          M_HTML.Clear;
          M_HTML.Lines.AddStrings(M_HTML_in.Lines);
          M_HTML.Lines.Add('  <TD colspan='+IntToStr(S_Spelen.Value+1)+'><center><b>Tijdenoverzicht</b></center></TD>');
          M_HTML.Lines.Add(' </TR>');
          M_HTML.Lines.Add('  <TD><b>Tijd</b></TD>');
          for i := 1 to S_Spelen.Value do
            M_HTML.Lines.Add('  <TD><b>' + L_Spelen.Items[i-1] + '</b></TD>');
          M_HTML.Lines.Add(' </TR>');
          for i := 1 to S_Spelen.Value do
          begin
            M_HTML.Lines.Add(' <TR>');
            M_HTML.Lines.Add('  <TD><b>' + StringGrid_Tijden.Cells[1,i] + '</b></TD>');
            for j := 1 to S_Spelen.Value do
            begin
              M_HTML.Lines.Add('  <TD><FONT FACE=Arial size=2>' +
                                  StringGrid_Overzicht.Cells[i,j] + '</FONT></TD>');
            end;
            M_HTML.Lines.Add(' </TR>');
          end;
          M_HTML.Lines.Add('</Table>');
          M_HTML.Lines.Add('<p>');
          M_HTML.Lines.Add('<Table>');
          M_HTML.Lines.Add(' <TR>');
           M_HTML.Lines.Add('  <TD valign=top>');
         M_HTML.Lines.Add('<Table CELLPADDING=2 BORDER=1 BGCOLOR="#cccccc">');
          M_HTML.Lines.Add('<TR>');
          M_HTML.Lines.Add('  <TD colspan=2><center><b>De spelen</b></center></TD>');
          M_HTML.Lines.Add(' </TR>');
          for i := 1 to S_Spelen.Value do
          begin
            M_HTML.Lines.Add(' <TR>');
            M_HTML.Lines.Add('  <TD><b>' + IntToStr(i) + '</b></TD>');
            M_HTML.Lines.Add('  <TD>' + L_Spelen.Items[i-1] + '</TD>');
            M_HTML.Lines.Add(' </TR>');
          end;
          M_HTML.Lines.Add('</Table>');
          M_HTML.Lines.Add('  </TD>');
          M_HTML.Lines.Add('  <TD>&nbsp;</TD>');
          M_HTML.Lines.Add('  <TD valign=top>');
          M_HTML.Lines.Add('<Table CELLPADDING=2 BORDER=1 BGCOLOR="#cccccc">');
          M_HTML.Lines.Add('<TR>');
          M_HTML.Lines.Add('  <TD colspan=2><center><b>De Teams</b></center></TD>');
          M_HTML.Lines.Add(' </TR>');
          for i := 1 to S_Teams.Value do
          begin
            M_HTML.Lines.Add(' <TR>');
            M_HTML.Lines.Add('  <TD><b>' + IntToStr(i) + '</b></TD>');
            M_HTML.Lines.Add('  <TD>' + L_Teams.Items[i-1] + '</TD>');
            M_HTML.Lines.Add(' </TR>');
          end;
          M_HTML.Lines.Add('</Table>');
           M_HTML.Lines.Add('  </TD>');
            M_HTML.Lines.Add(' </TR>');
          M_HTML.Lines.AddStrings(M_HTML_end.Lines);
          M_HTML.Lines.SaveToFile(sd_overzicht.filename);
        end;
      end;
    2:begin // Aanpassingen
      end;
    3:begin // Spelresultaten
        if sd_resultaten.execute then
        begin
          M_HTML.Clear;
          M_HTML.Lines.AddStrings(M_HTML_in.Lines);
          M_HTML.Lines.Add('  <TD><b>Tijd</b></TD>');
          for i := 1 to S_Spelen.Value do
            M_HTML.Lines.Add('  <TD><b>' + L_Spelen.Items[i-1] + '</b></TD>');
          M_HTML.Lines.Add(' </TR>');
          for i := 1 to S_Spelen.Value do
          begin
            M_HTML.Lines.Add(' <TR>');
            M_HTML.Lines.Add('  <TD><b>' + StringGrid_Tijden.Cells[1,i] + '</b></TD>');
            for j := 1 to S_Spelen.Value do
            begin
              M_HTML.Lines.Add('  <TD><FONT FACE=Arial size=2>' +
                                  StringGrid_Overzicht.Cells[i,j] + '<br>' +
                                  StringGrid_Uitslag.Cells[i,j] + '</FONT></TD>');
            end;
            M_HTML.Lines.Add(' </TR>');
          end;
          M_HTML.Lines.AddStrings(M_HTML_end.Lines);
          M_HTML.Lines.SaveToFile(sd_resultaten.filename);
        end;
        // wegschrijven van resultaten voor nader gebruik, zie geheel bovenaan
        filename := dir + '\' + ResultFile;
        AssignFile(Fout, filename);
        {$I-}
        Rewrite(Fout);
        {$I+}
        if IOResult <> 0 then
          MessageDlg('Schrijffout : ' + filename, mtInformation, [mbOk], 0)
        else
        begin
          for i := 1 to S_Spelen.Value do
            for j := 1 to S_Spelen.Value do
              if klaar[i,j] then
                writeln(Fout, i, ' ', j, ' ', Uitslag[2*i-1,j], ' ', Uitslag[2*i,j]);
          CloseFile(Fout);
        end;
        // wegschrijven van minmax
        filename := dir + '\' + GameTypeFile;
        AssignFile(Fout, filename);
        {$I-}
        Rewrite(Fout);
        {$I+}
        if IOResult <> 0 then
          MessageDlg('Schrijffout : ' + filename, mtInformation, [mbOk], 0)
        else
        begin
          for i := 1 to S_Teams.Value do writeln(Fout, StringGrid_Spelen.Cells[1,i]);
          CloseFile(Fout);
        end;
        // wegschrijven van jokers
        filename := dir + '\' + JokerFile;
        AssignFile(Fout, filename);
        {$I-}
        Rewrite(Fout);
        {$I+}
        if IOResult <> 0 then
          MessageDlg('Schrijffout : ' + filename, mtInformation, [mbOk], 0)
        else
        begin
          for i := 1 to S_Teams.Value do writeln(Fout, Jokers[i]);
          CloseFile(Fout);
        end;
      end;
    4:begin // Puntenoverzicht
        if sd_punten.execute then
        begin
          M_HTML.Clear;
          M_HTML.Lines.AddStrings(M_HTML_in.Lines);
          M_HTML.Lines.Add('  <TD><b>Team</b></TD>');
          M_HTML.Lines.Add('  <TD><b>Totaal</b></TD>');
          for i := 1 to S_Spelen.Value do
            M_HTML.Lines.Add('  <TD><b>' + L_Spelen.Items[i-1] + '</b></TD>');
          M_HTML.Lines.Add(' </TR>');
          for i := 1 to S_Teams.Value do
          begin
            M_HTML.Lines.Add(' <TR>');
            M_HTML.Lines.Add('  <TD><b>' + L_Teams.Items[i-1] + '</b></TD>');
            M_HTML.Lines.Add('  <TD><b>' + IntToStr(Totaal[i]) + '</b></TD>');
            for j := 1 to S_Spelen.Value do
              M_HTML.Lines.Add('  <TD>' + IntToStr(Punten[i,j]) + '</TD>');
            M_HTML.Lines.Add(' </TR>');
          end;
          M_HTML.Lines.AddStrings(M_HTML_end.Lines);
          M_HTML.Lines.SaveToFile(sd_punten.filename);
        end;
      end;
    5:begin // Uitslag
        if sd_uitslag.execute then
          with StringGrid_Totaal do
          begin
            M_HTML.Clear;
            M_HTML.Lines.AddStrings(M_HTML_in.Lines);
            M_HTML.Lines.Add('  <TD><b>Rang</b></TD>');
            M_HTML.Lines.Add('  <TD><b>Team</b></TD>');
            M_HTML.Lines.Add('  <TD><b>Punten</b></TD>');
            M_HTML.Lines.Add('  <TD><b>Joker</b></TD>');
            M_HTML.Lines.Add(' </TR>');
            for i := 1 to S_Teams.Value do
            begin
              M_HTML.Lines.Add(' <TR>');
              M_HTML.Lines.Add('  <TD><b>' + Cells[0,i] + '</b></TD>');
              M_HTML.Lines.Add('  <TD><b>' + Cells[2,i] + '</b></TD>');
              M_HTML.Lines.Add('  <TD>' + Cells[3,i] + '</TD>');
              M_HTML.Lines.Add('  <TD>' + Cells[4,i] + '&nbsp;</TD>');
              M_HTML.Lines.Add(' </TR>');
            end;
            M_HTML.Lines.AddStrings(M_HTML_end.Lines);
            M_HTML.Lines.SaveToFile(sd_uitslag.filename);
          end;
      end;
  end;
end;

///////////////////
// B_ClearClick
///////////////////
procedure TF_Main.B_ClearClick(Sender: TObject);
begin
  DeleteFile(dir + '\' + InitFile);
  DeleteFile(dir + '\' + TeamFile);
  DeleteFile(dir + '\' + GameFile);
  DeleteFile(dir + '\' + TimeFile);
  DeleteFile(dir + '\' + GameTypeFile);
  DeleteFile(dir + '\' + JokerFile);
  DeleteFile(dir + '\' + ResultFile);
end;

///////////////////
// B_ExitClick
///////////////////
procedure TF_Main.B_ExitClick(Sender: TObject);
begin
  Close
end;

end.
